package com.tptj.demo.hg.java.script.action.provider;

import com.fr.intelli.record.Focus;
import com.fr.js.AbstractJavaScript;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.StringUtils;
import com.fr.stable.web.Repository;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-04-28
 **/
@EnableMetrics
public class DemoScript extends AbstractJavaScript {

    private String data;

    @Override
    @Focus(id="com.tptj.demo.hg.java.script.action.provider.v10",text = "JavaScriptActionProvider")
    protected String actionJS(Repository repository) {
        return "alert(\""+data+"\");";
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    private final static String XML_TAG = "DemoScript";

    @Override
    public void readXML(XMLableReader reader) {
        super.readXML(reader);
        String name = reader.getTagName();
        if ( XML_TAG.equals(name) ) {
            data = reader.getAttrAsString("data", StringUtils.EMPTY);
        }
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        super.writeXML(writer);
        writer.startTAG(XML_TAG).attr("data",data).end();
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        DemoScript obj = (DemoScript)super.clone();
        obj.data = data;
        return obj;
    }

    @Override
    public String toString() {
        return actionJS(null);
    }
}
